;   le batch pour batir une librairie
;batch,sources et .inc (contenant les proto)
;sont a mettre dans le mme rpertoire \masm32\perso

            comment ?
@echo off

echo        Assembling library modules.
echo.
\masm32\bin\ml /c /coff *.asm
\masm32\bin\lib *.obj /out:perso32.lib

: The following line works as well
: \masm32\bin\link -lib "*.obj" "/out:masm32.lib"

pause

echo.
del *.obj
copy        perso32.lib \masm32\lib\perso32.lib
copy        perso32.inc \masm32\include\perso32.inc
echo.
echo        "perso32.LIB & perso32.INC have been copied"
echo        "to the LIB & INCLUDE directories."
echo.
pause
@echo off
                                        ?

; #########################################################################

      .386                      ; force 32 bit code
      .model flat, stdcall      ; memory model & calling convention
      option casemap :none      ; case sensitive

      ; -------------------------------------------------------------------
      ; Les fichiers inclus ii ,AUCUN .lib c'est au programme utilisateur
      ;	de les fournir
      ; -------------------------------------------------------------------
       include \masm32\include\windows.inc
       include \masm32\include\gdi32.inc
      ; include \masm32\include\user32.inc
      	include \masm32\include\kernel32.inc
      ; include \masm32\include\masm32.inc
       include macros.txt	

      ; ---------------------------------------------------------
      ; Les PROTO sont tous regroups dans un fichier .inc du mme
      ; nom que la librairie .lib
      ; ---------------------------------------------------------
SearchAdresse PROTO PRIVATE  :DWORD,:DWORD,:DWORD
Unload_msvcrt PROTO 
Load_msvcrt PROTO  :DWORD
crt_atol PROTO C :DWORD 
crt_div PROTO C :DWORD,  :DWORD 
crt_isalpha PROTO C :DWORD 
crt_islower PROTO C :DWORD 
crt_isupper PROTO C :DWORD 
crt_fabs PROTO C :QWORD 
 

	Patol TYPEDEF PROTO C :DWORD
	Fatol TYPEDEF PTR Patol
	acrt_atol TEXTEQU <Fatol ptr ADRatol>

	Padiv TYPEDEF PROTO C :DWORD ,:DWORD
	Fadiv TYPEDEF PTR Padiv
	acrt_div TEXTEQU <Fadiv ptr ADRdiv>

	Pisalpha TYPEDEF PROTO C :DWORD
	Fisalpha TYPEDEF PTR Pisalpha
	acrt_isalpha TEXTEQU <Fisalpha ptr ADRisalpha>

	Pislower TYPEDEF PROTO C :DWORD
	Fislower TYPEDEF PTR Pislower
	acrt_islower TEXTEQU <Fislower ptr ADRislower>

	Pisupper TYPEDEF PROTO C :DWORD
	Fisupper TYPEDEF PTR Pisupper
	acrt_isupper TEXTEQU <Fisupper ptr ADRisupper>

	Pfabs TYPEDEF PROTO C :QWORD
	Ffabs TYPEDEF PTR Pfabs
	acrt_fabs TEXTEQU <Ffabs ptr ADRfabs>


      ; 
      ;exemples de definitions externes
      ; 	EXTERNDEF Copier :PROTO  :DWORD,:DWORD
      ; 	EXTERNDEF EtatMemoirePile :MEMORY_BASIC_INFORMATION 
      ; 	EXTERNDEF PoriginePile:DWORD			
.const
	
   .data	
	Hmsvcrt dd 0
	ADRatol dd 0
	 db "atol",0
	ADRdiv dd 0
	 db "div",0
	ADRisalpha dd 0
	 db "isalpha",0
	ADRislower dd 0
	 db "islower",0
	ADRisupper dd 0
	 db "isupper",0
	ADRfabs dd 0
	 db "fabs",0
		dd 0,0 ;mark the end of the array
    .code


;################################################################
crt_fabs PROC C un:QWORD 
	invoke acrt_fabs,un
         ret
crt_fabs endp
;################################################################
crt_isupper PROC C un:DWORD 
	invoke acrt_isupper,un
         ret
crt_isupper endp

;################################################################
crt_islower PROC C  un:DWORD 
	invoke acrt_islower,un
         ret
crt_islower endp
;################################################################
crt_isalpha PROC C un:DWORD 
	invoke acrt_isalpha,un
         ret
crt_isalpha endp

;################################################################
crt_atol PROC C un:DWORD 
	invoke acrt_atol,un
         ret
crt_atol endp
;################################################################
crt_div PROC C un:DWORD,  deux:DWORD 
	invoke acrt_div,un,deux 
         ret
crt_div endp
;################################################################
Load_msvcrt PROC  pmsvcrtdll:DWORD 
	invoke SearchAdresse,pmsvcrtdll,addr Hmsvcrt,addr ADRatol 
         ret
Load_msvcrt endp

;################################################################

Unload_msvcrt PROC 
			Local  retour:DWORD
         mov retour,1
	.if Hmsvcrt != 0
		invoke FreeLibrary,Hmsvcrt
	.endif

 FindeUnload_msvcrt:
         mov eax,retour
         ret
Unload_msvcrt endp

;################################################################




; #########################################################################
	;utilisation du proc 
	;IN name adress of the dll
	;IN OUT adress of the dll handle
	;IN adress of the first DWORD of the data array created,begin by ADR...
	;example
	invoke SearchAdresse,SADR("msvcrt.dll"),addr Hmsvcrt,addr ADRatol
SearchAdresse PROC uses esi edi pNomDLL:DWORD,pHdll:DWORD,pFirstAdresse:DWORD
				Local  retour:DWORD
				Local  Hldll:DWORD
				;Local    [LimiteMaxPhrase]:BYTE 
	      mov retour,0
		invoke LoadLibrary,pNomDLL
		mov edi,pHdll
		mov [edi],eax
		mov Hldll,eax
		.if eax == 0
			;invoke RetrouveMessageErreur, SADR("LoadLibrary failed")"
			jmp FindeSearchAdresse
		.endif
		mov esi,pFirstAdresse
		NouvelleAdresse:
		mov edi,esi
		add esi,4
		invoke GetProcAddress,Hldll,esi
		mov [edi],eax
			.if eax == 0
				;invoke RetrouveMessageErreur,esi
				;jmp FindeSearchAdresse
			.endif
		;passer le nom
		@@:
		.if byte ptr [esi] != 0
			inc esi
			jmp @B
		.endif
		inc esi			;passe le zero de fin de nom
		.if dword ptr [esi+4] != 0
			jmp NouvelleAdresse
		.endif
		mov retour,1
	 FindeSearchAdresse:
	         mov eax,retour
	         ret
SearchAdresse endp

end